;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Soft Scheme - Copyright (c) 1993,1994 by Andrew K. Wright
;; See LICENSE for a full description of the license terms.


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Soft Type reconstruction for Scheme, SLIB version

;; Installation options:

;; match-file must be an absolute pathname or #f
(define match-file "/pls/accts/wright/scheme/match/match-slib.scm")

;; installation directory must be an absolute pathname ending in a slash
(define installation-directory "/pls/accts/wright/soft/scheme/release/")

;; customization-file must be a path relative to installation-directory, or #f
(define customization-file #f)

;; fastlibrary-file must be a path relative to installation-directory, or #f
(define fastlibrary-file #f)

;;;;;;;;;;;;;;;;

(define st:version "SLIB Version 0.18, April 21, 1995")

(and match-file (load match-file))

(define home-directory
  (or (getenv "HOME")
      (error "environment variable HOME is not defined")))

(defmacro recur args
  `(let ,@args))

(defmacro rec args
  (match args
    (((? symbol? x) v)
     `(letrec ((,x ,v)) ,x))))

(defmacro parameterize args
  (match args
    ((bindings exp ...)
     `(begin ,@exp))))

(define gensym gentemp)
(define expand-once macroexpand-1)

(**INCLUDE** "encapsulate.scm")

(**INCLUDE** "basiclib-slib.scm")
(**INCLUDE** "checklib.scm")

(encapsulate
  (st:help st: st:check st:run st:bench st:type st:ltype st:cause st:control st:summary st:defprim st:deftype)

  ((string-append installation-directory "intro-slib.scm")

   (string-append installation-directory "library.scm")
   (string-append installation-directory "data.scm")

   (string-append installation-directory "parse.scm")
   (string-append installation-directory "macros.scm")
   (string-append installation-directory "env.scm")

   (string-append installation-directory "types.scm")
   (string-append installation-directory "tidy.scm")
   (string-append installation-directory "init.scm")
   (string-append installation-directory "prim.scm")

   (string-append installation-directory "bind.scm")
   (string-append installation-directory "improve.scm")
   (string-append installation-directory "improve-match.scm")

   (string-append installation-directory "components.scm")
   (string-append installation-directory "top-sort.scm")

   (string-append installation-directory "typechk.scm")

   (string-append installation-directory "unparse.scm")
   (string-append installation-directory "display-check.scm")
   (string-append installation-directory "display-cause.scm")
   (string-append installation-directory "display-type.scm")

   (string-append installation-directory "drivers.scm"))

  (init!))
